# node.js入门学习

###  一 node的起源

* 2009年Ryan Dahl利用Google的V8引擎打造了给予事件循环实现的异步I/O框架。
* Node发展为一个强制不共享任何资源的单线程、单进程系统，包含十分适宜的网络库，为构建大型分布式应用程序提供基础设施，其目标也是成为一个构建快速，可伸缩的网络应用平台。   通过通信协议来组织许多node,非常容易来扩展来达成构建大型网络应用的目的。
* 每一个node进程都构成这个网络应用中的一个节点。

### 二  node的特点

* node除了HTML、WebKit和显卡这些UI相关技术没有支持外,Node的结构与chrome十分相似。

* 浏览器通过事件驱动来服务界面上的交互；node通过事件驱动来服务I/O。

1. 异步I/O
  Ryan Dahl排除万难，在底层构建了很多异步I/O的API，从文件读取到网络请求等。——-----》并行IO操作

2. 事件与回调函数

3. 单线程
* node保持了javascript在浏览器中单线程的特点，且javascript与其余线程时无法共享任何状态的。优点：
  不用像多线程那样处处在意状态的同步问题，也即没有死锁的存在，没有线程上下文交换所带来的性能上的开销。
  缺点：
  无法利用多核CPU

* 为了解决计算，将需要计算的程序发送给其它***进程***。在结果得出后，通过事件将结果传递回来。
    
    （1）是GoogleМՂ开发的Gears。
    
    （2）HTML5定制了Web Workers标准

4. 跨平台(Node基于libuv实现跨平台的架构示意图)
  v0.6.0——node可以在windows上运行

  Node.js----->libuv------->*nix
                     ------>Windows

  > 目前，除了没更新的C+模块外，大部分C++模块都能实现跨平台的兼容

### 三  Node的应用场景

1. IO密集型和CPU密集型

  对于CPU密集型应用（如果耗时超过普通阻塞I/O的耗时，那么应用场景就需要重新评估）应当采用多线程来计算，但是Node可以采用如下两种方式：

  （1）Node可以􁤯过编写c/c++扩展的方式高效利用CPU
   
  （2）通过子进程方式，将一部分node进程当作常驻服务进程用于计算。然后利用进程间的消息来传递结果，将计算与I/O分离，这样能充分利用多CPU

    cpu密集不可怕，如何合理调度是诀窍。

2. 与遗留系统和平共处（java，node提供接口）

3. 分布式应用（并行查询数据库）

# Nodejs模块机制

### 一 CommonJS规范
 
> javascript的表现能力取决于宿主环境中的API支持度。

> javascript自身缺陷：
  
  （1）没有模板系统

  （2）标准库较少

  （3）没有标准接口

  （4）缺乏包管理系统

CommonJS规范的提出，解决上述问题。

1. 模块的引用

var math = require('math');

2. 模块的定义

一个文件就是一个modulde对象，exports是module的属性. 将方法挂载在exports对象上作为属性即可定义导出的方式。

在另一个文件中，我们通过require（）方法引入模块后，就能调用定义的属性或方法了。

3. 模块标识

require(路径和文件名)

# 二. 模块编译

## 1. 引入模块（路径分析，文件定位，编译执行）

CommonJS模块规范允许不加文件扩展名，这种情况下，Node会按js,.json,.mode的次序补足扩展名，依次尝试。

## 2. 浏览器仅仅缓存文件，而node缓存的是编译和执行之后的对象:

> require()方法对相同模块的二次加载一律采用缓存优先的方式。不同之处核心模块的缓存检查先于文件模块的缓存检查。

> 核心模块的优先级仅次于缓存加载，它在Node的源代码编译过程中已经编译为二进制代码，其加载过程更快。

## 3. 模块开始编译

  (1) ***定位到具体的文件后，node会新建一个模块对象，然后根据路径载入并编译。***

  (2)***每一个编译成功的模块都会将其文件路径作为索引缓存在Module._cache对象上，以提高二次引入的性能。***

### 3.1  javascript模块的编译

在***编译***过程中，node对获取的javascript文件内容进行了头尾包装，在头部添加了:
```javascript
function(exports,require,_filename,_dirname)
{
 var math=require('math');
  exports.area=function(radius)
  {
    return Math.PI*radius*radius
  };
});
1.module.exports 初始值为一个空对象 {}
2.exports 是指向的 module.exports 的引用
3.require() 返回的是 module.exports 而不是 exports
4.所有export收集到的方法都赋值给了module.exports。这里有个前提：module.exports本身不具备任何属性和方法，如果module.exports已经具备一些属性和方法，那么export之前收集的信息将被忽略。
```
* 通过这种方式，起到了exports属性上的任何方法和属性都可以被外部调用到，但是模块的其余变量或者属性则不可直接被调用。

* module.exports采用这种迂回的方式，主要是避免直接exports=function(){}改变形参的值，从而不能改变作用域外的值。

### 3.2 c/c++模块的编译

   pross.dlopen()来实现。***实际上.node模块文件并不需要编译***，因为它是编写c/c++模块之后编译生成的，所以这里只有加载和执行的过程。

### 3.3 JSON文件的编译

node利用fs模块同步读取JSON文件内容之后，调用JSON.parse()方法得到对象，然后将它赋给模块对象的exports,以供外部调用。

###3.4 核心模块编译

见nodejs核心模块的编写和编译

# node.js 6.10.0交叉编译
