### 第七章 网络编程

Node提供了如下4个模块，分别用于处理TCP、UDP、HTPP、HTTPS
* NET
* dgram
* http
* https

## 7.1 构建TCP服务

### 7.1.1 构建TCP服务器

```javascript
var net = require('net');
var server = net.createServer(function (socket) {
    // 􁂎的􀫶接
    socket.on('data', function (data) {
    socket.write("􀱇􀡻");
});
socket.on('end', function () {
    onsole.log('􀫶接􀜏开');
});
socket.write("􀣌􁆓􀠼􀬣􀄖􀸨入􀴱出Node.js􀄗􀹖􀫩：\n");
});
server.listen(8124, function () {
    console.log('server bound');
});
server.listen(8124, function () {
console.log('server bound');
});

或者如下：
var server = net.createServer();
server.on('connection', function (socket) {
// 􁂎的􀫶接
});
server.listen(8124);
```
### 7.1.1 TCP服务事件
(1) 服务器事件
* Listening
* connection
* close
* error
（2） 连接事件
* date
* end
* connect
* error
* close
* timeout

## 7.2构建UDP服务
```JAVA
var dgram = require("dgram");
var server = dgram.createSocket("udp4");
server.on("message", function (msg, rinfo) {
    console.log("server got: " + msg + " from " +
    rinfo.address + ":" + rinfo.port);
});
server.on("listening", function () {
    var address = server.address();
    console.log("server listening " +
    address.address + ":" + address.port);
});
server.bind(41234);
```
 
### 7.1.1 UDP套接字事件
UDP套接字，只是一个EventEmitter的实例，而非Stream的实例，它具备如下自定义事件：

* message
* listening
* close
* error

## 7.2 构建HTTP服务

```javascript
var http = require('http');
    http.createServer(function (req, res) {
    res.writeHead(200, {'Content-Type': 'text/plain'});
    res.end('Hello World\n');
}).listen(1337, '127.0.0.1');
console.log('Server running at http://127.0.0.1:1337/
```

### 7.2.1 HTTP报文
```javascript
    $ curl -v http://127.0.0.1:1337
    //三次握手
    * About to connect() to 127.0.0.1 port 1337 (#0)
    * Trying 127.0.0.1...
    * connected
    * Connected to 127.0.0.1 (127.0.0.1) port 1337 (#0)
    //完成握手收后，客户端向服务器发送请求报文
    > GET / HTTP/1.1
    > User-Agent: curl/7.24.0 (x86_64-apple-darwin12.0) libcurl/7.24.0 OpenSSL/0.9.8r zlib/1.2.5
    > Host: 127.0.0.1:1337
    > Accept: */*
    //服务器完成处理后，向客户端发送响应内容（响应头+响应体）
    >
    < HTTP/1.1 200 OK
    < Content-Type: text/plain
    < Date: Sat, 06 Apr 2013 08:01:44 GMT
    < Connection: keep-alive
    < Transfer-Encoding: chunked
    <
    Hello World
    //最后部分是结束会话信息
    * Connection #0 to host 127.0.0.1 left intact
    * Closing connection #0
```

### 7.2.2 HTTP请求
ServerRequest
```javascript
function (req, res) {
res.writeHead(200, {'Content-Type': 'text/plain'});
res.end('Hello World\n');
}

function (req, res) {
// console.log(req.headers);
var buffers = [];
req.on('data', function (trunk) {
buffers.push(trunk);
}).on('end', function () {
var buffer = Buffer.concat(buffers);
// TODO
res.end('Hello world');
});
}
```
### 7.2.2 HTTP响应
ServerResponse
ClientRequest

```c
setHeader()
riteHead(）: res.writeHead(200, {'Content-Type': 'text/plain'});
```
```c
res.write()和res.end()的区别，res.end()会先调用write()发送数据。
```

默认情况下，通过ClientRequest对象对同一个服务器发起的HTTP请求最多可以创建5个连接，它的实质就是一个连接池。
