# Node的异步IO


### 请求对象

* javaScript发起调用到内核执行I/O操作的过程中，存在的中间工程，就叫请求对象。
* 请求对象是异步I/O过程中的重要中间产物，所有状态都保存在这个对象中。

（1）libuv通过运用`uv_fs_open（）`方法调用时，会创建一个`FSReqWrap`请求对象，从javaScript层传入的参数和当前方法都封装在这个请求对象中。其中回调函数也被设置在这个对象的oncomplete_sym属性上。

`req_wrap->object_->Set(oncomplete_sym, callback);`

（2）对象包装完毕后，Windows下调用QueueUserWorkItem()方法将这个FSReqWrap对象推入到I/O线程池中等待执行。

```c+++
QueueUserWorkItem(&uv_fs_thread_proc, \  第一个参数是将要执行的方法的引用——uv_fs_thread_proc
req, \        第二个参数是uv_fs_thread_proc运行时所需要的参数
WT_EXECUTEDEFAULT   //第三个参数是执行的标志
)
```

### 事件循环，典型的生产者/消费者模型
每个tick过程会查看是否有时间待处理

### 观察者———判断是否有事件需要处理


### 执行回调

线程池中的I/O操作完毕之后，会将获取的结果存储在req->result属性上。

（1）调用PostQueuedCompletionStatus()通知IOCP，告知当前对象操作已经完成。并且将线程归还线程池。


`PostQueuedCompletionStatus((loop)->iocp, 0, 0, &((req)->overlapped))`


（2）每个Tick中，调用事件循环的I/O观察者。调用IOCP相关的`GetQueuedCompletionStatus()`方法检查线程池中是否有执行完的请求。如果有则加入到I/O观察者的队列中，当做事件处理。

（3）观察者取出“请求对象”的resulet属性作为参数，取出`oncomplete_sym`属性作为方法，然后调用执行。