# 第八章 构建Web应用

Connet

Express(MVC框架)

## 8.1 基础功能

* request事件发生于网络建立，客户端向服务端发送报文，服务端解析报文，发现HTTP请求的报头时，***在已触发request事件钱***，它已准备好***ServerRuest***和***ServerResponse***对象以供请求和响应报文的操作。

* 另外，可以将一个参数传递给createServer(）方法作为request事件的侦听器。
```javascript
var http = require('http');
http.createServer(function (req, res) {
res.writeHead(200, {'Content-Type': 'text/plain'});
res.end('Hello World\n');
}).listen(1337, '127.0.0.1');
console.log('Server running at http://127.0.0.1:1337/');

var app = connect();
// var app = express();
// TODO
http.createServer(app).listen(1337);
```
### Web需求：
    * 请求方法的判断
    * URL路径解析
    * URL查询字符串解析
    * Cookie的解析
    * Basic认证://auth􁽙Basic认􁝼，这个􀏘􀠱􁜁􁝟􁊪􀩆请􀶺􀜿中的Authorization部
    * 表单数据的解析
    * 任意格式文件的上传处理
    * 还有Session（会话）d的需求

### 请求方法

* PUT ：新建一个资源

* POST ：更新一个资源

* GET： 查看一个资源

* DELET : 删除一个资源

```javascript
function (req, res) {
    switch (req.method) {
        case 'POST':
          update(req, res);
         break;
        case 'DELETE':
            remove(req, res);
        break;
        case 'PUT':
         create(req, res);
         break;
        case 'GET':
            default:
            get(req, res);
    }
}
```
* 路径解析


Session数据只保留在服务器端，客户端无法修改。（有效期普遍设置在20分钟）

将分散到多个进程里的数据统一转移到集中的数据存储中，目前常用的工具是Redis、Memcached等
## 数据上传

### POST请求

报头+内容


通过报头的Transfer-Encoding或Content-Length即可判断请求中是否带有内容，
```javascript
（1）查看请求中是否带有内容，内容部分通过data事件触发。
var hasBody = function(req) {
return 'transfer-encoding' in req.headers || 'content-length' in req.headers;
};
（2）
function (req, res) {

    if (hasBody(req)) {
    v   ar buffers = [];
    req.on('data', function (chunk) {
    b   uffers.push(chunk);
    });
req.on('end', function () {
    req.rawBody = Buffer.concat(buffers).toString();//转换为字符串
    handle(req, res);
    });
    } else {
    handle(req, res);
    }
}
```


### 表单数据
Content-Type: application/x-www-form-urlencoded
<form action="/upload" method="post">
<label for="username">Username:</label> <input type="text" name="username" id="username" />
<br />
<input type="submit" name="submit" value="Submit" />
</form>
### JSON数据
Content-Type: application/json; charset=utf-8

### XML文件
```javascript
var xml2js = require('xml2js');
var handle = function (req, res) 
{
    if (mime(req) === 'application/xml')
     {
        xml2js.parseString(req.rawBody, function (err, xml) {
            if (err) {
            // 异常内容􀇈响应Bad request
            res.writeHead(400);
            res.end('Invalid XML');
            return;
            }
            req.body = xml;
            todo(req, res);
        });
    }
};
```
### 附件上传
```javascript
<form action="/upload" method="post" enctype="multipart/form-data">
<label for="username">Username:</label> <input type="text" name="username" id="username" />
<label for="file">Filename:</label> <input type="file" name="file" id="file" />
<br />
<input type="submit" name="submit" value="Submit" />
</form>
```
当用multipart/form-data表单提交时，构造的请求报文与普通表单完全不同，首先它的报头如下所示：
```javascript
Content-Type: multipart/form-data; boundary=AaB03x
Content-Length: 18231
```

将req这个流对象直接交给对应的解析方法，由解析方法，自行处理上传的接受内容并保存在内存中。
```javascript

var formidable = require('formidable');

function (req, res) {
    if (hasBody(req)) {
    if (mime(req) === 'multipart/form-data') {
        var form = new formidable.IncomingForm();
        form.parse(req, function(err, fields, files) {
            req.body = fields;
            req.files = files;
            handle(req, res);
            });
        }
    } 
    else 
    {
    handle(req, res);
    }
}

```

### 数据上传与安全
 内存限制

 CSRF（Cross-Site Request Forgery）

## 路由解析